#!/usr/bin/python
# .: coding: utf-8 :.
#
# Ta var på inntil n pakker fra en klient. Gi beskjed når taket er nådd.
#

class MaxSamplesReached(Exception):
    pass



class ClientStorage():
    """
    Lagre inntil n pakker for en klient, mens grensesnittet stort sett holdes
    likt TemporalStorage sitt
    """
    def __init__(self, packets=None, bytes=None): #, maxsamples=None):
        # {'clientidentifier': [[list of packets], last_yield], .. }
        self.ds = {}
        pass

    def expunge(self, client):
        if not self.ds[client]:
            raise Exception, 'No data for client seen, unable to expunge'
        self.ds[client][0] = []

    def get_clients(self):
        return self.ds.keys()

    def get_data(self, client):
        return self.ds[client][0]

    def should_yield(self, client):
        raise Exception, "subclassing needed"

    def add(self, client, hdr, p):
        if not self.ds.has_key(client):
            # packetlist, yieldtime
            self.ds[client] = [ [], None]

        self.ds[client][0].append( (hdr, p ) )

        if self.should_yield(client):
            return len(self.ds[client][0])

            #if self.samples_max and self.samples_made >= self.samples_max:
            #    # control is from Decoder.start(), so this is a bit dirty.
            #raise MaxSamplesReached()
        return None

class PacketClientStorage(ClientStorage):
    """
    En ClientStorage som produserer samples hvert n-te pakke
    """
    def __init__(self, packets=50):
        ClientStorage.__init__(self)
        self.maxpackets = packets

    def should_yield(self, client):
        return len(self.ds[client][0]) >= self.maxpackets


class ByteClientStorage(ClientStorage):
    """
    En ClientStorage som produserer samples etter n byte med pakker
    per klient.
    """
    def __init__(self, bytes):
        ClientStorage.__init__(self)
        self.maxbytes = bytes

    def should_yield(self, client):
        # teller hele pakkestørrelsen.
        #print len(self.ds[client][0])
        # sannsynligvis urimelig treig, flytt til add-rutina.
        totlen = 0
        for hdr, data in self.ds[client][0]:
            totlen += data.get_size()
            #(hdr, data) = self.ds[client][0][0]
        res = totlen >= self.maxbytes
        return res

