#!/usr/bin/python
# .- coding: utf-8 -.
# 
# Rapporteringsrutine for dict(iodClientFinder.bandits)

import os, sys

from ClientStorage import ClientStorage, PacketClientStorage
from ClientStorage import ByteClientStorage
from iodClientFinder import iodClientFinder
from iodClientFinderKolmo import iodClientFinderKolmo

class EagleReporter:
    def __init__(self, config, filename, bandits, veryfirstts):
        self.config = config
        self.filename = filename
        self.bandits = bandits
        self.veryfirstts = veryfirstts

    def hent_positiver(self, fname=None):
        """
        Hardkodet liste over kjente positiver i datafilene, 
        slik at rapporteringen kan gjøres automatisk.
        """
        if not fname:
            fname = self.filename
        positiver = {"dnspacketdump-2010-04-27-lkarsten.pcap": set(["129.241.208.220"]) }
        
        spesielle = ["iodine-login.pcap", "iodine-poll.pcap",
        "iodine-mp3stream.pcap", "iodine-ssh.pcap",
        "iodine-web.pcap", "nstx-login.pcap", "nstx-poll.pcap",
        "nstx-ssh-mtu500.pcap", "nstx-ssh-mtu1500.pcap",
        "nstx-web.pcap", "tuns-login.pcap", "tuns-poll.pcap",
        "tuns-ssh.pcap", "tuns-web.pcap"]
        
        for i in spesielle:
            positiver[i] = set(["10.51.1.140"]) 

        res = positiver.get(fname )
        if not res:
            res = set([])
        #print "Filen %s har %s kjente positiver: %s" % \
        # (fname, len(res), ",".join(res))
        return res

    def report(self):
        raise Exception, "subclass"


class EagleLatexReporter(EagleReporter):
    def report(self):
        bname = self.filename
        fname = os.path.basename(self.filename)
        kjente_pos = self.hent_positiver(fname=fname)

        import pprint
        #pprint.pprint(eagle.banditstore)

        # friske opp utskriften litt
        bname = bname.replace("dnspacketdump-", "") 
        bname = bname.replace("-lkarsten", "")
        bname = bname.replace("../datafiles/", "")
        bname = bname.replace(".pcap", "")
        print bname,

        print "& %.0f" % self.config["numpackets"],
        print "& %.2f" % self.config["kolmo_minimum"],

        # positiver
        pos = set(self.bandits.keys())
        # et sett med ipadressene til falske positiver
        falskpos = pos - kjente_pos
        #print " pos:  %.0f & " % len(pos),
        # manglende kjente positiver. (falske negativer)
        fneg = kjente_pos - pos
        print "& %.0f av %i kjente (%i falske, %i mangler)" % \
                (len(pos), len(kjente_pos), len(falskpos), len(fneg)),

        print "& ",
        for ip in kjente_pos - fneg:
            m = self.bandits[ip][0]
            # alarmen går når samplet er slutt, og blitt regnet på.
            delta_t = m.get("last_ts") - self.veryfirstts
            delta_t_float = delta_t.seconds + (delta_t.microseconds / 1000000.)
            print "%0.2fs " % (delta_t_float),
        print " \\\\ \\hline"

