#!/usr/bin/python
# .: coding: utf-8 :.

class MaxSamplesReached(Exception):
    pass

class TemporalStorage():
    def __init__(self, period=10, maxsamples=None):
        # period kan vaere None, om man ikke vil at 
        # den skal spytte datasett innimellom.
        self.dt = period

        self.last_yield = None

        self.samples_made = 0
        self.samples_max = maxsamples 
        # a list of packets.
        self.ds = []
        pass

    def expunge(self):
        #print "expunging %s packets" % len(self.ds)
        self.ds = []

    def get_data(self):
        return self.ds

    def range(self):
        res = ( 
            self.ds[0][0].getts()[0],
            self.ds[-1][0].getts()[0]
            )
#        print res
        return res

    def add(self, hdr, p):
        self.ds.append( (hdr, p ))
        if not self.last_yield:
            # first packet
            self.last_yield = hdr.getts()[0]

        if self.dt and hdr.getts()[0] > (self.last_yield + self.dt):
            self.samples_made += 1
            self.last_yield = hdr.getts()[0]
            # nasty
            if self.samples_max and self.samples_made >= self.samples_max:
                # control is from Decoder.start(), 
                # so this is a bit dirty.
                raise MaxSamplesReached()
            return len(self.ds)
        return None

