#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Kolmogorov!

from iodClientFinder import iodClientFinder

class iodClientFinderKolmo(iodClientFinder):
    def __init__(self, config):
        iodClientFinder.__init__(self, config)
        self.persistant_store = {}  
        self.tick = {}

        self.banditstore = {}
        self.sample_stop_ts = None

    def analyze(self, client):
        """
        Gir denne klienten noen advarsel/alarm i dette samplet?
        returnerer True, false.

        Analyze the current sample """
        verbose = True
        veryverbose = True

        data = self.clistore[client]

        #print data["kolmoratio"]
        #print data["kolmoratio"]
        #return False

        #if client == "129.241.208.220":
        #    print data

        import pprint
        if data["kolmoratio"] > self.config["kolmo_minimum"]:
           #pprint.pprint(data)
           return True
        return False

    def timely_analysis(self, client, depth, verbose=False):
        """
        Analyse per klient, over tid. Om en klient sitt datasett
        gir alarm, vil det lagret her.  Maalet er aa se etter
        etterfoelgende alarmer, saa det vil fungere aa gruppere per
        bruker 
        """
        # shift
        if not self.tick.has_key(client):
            self.tick[client] = 0
        self.tick[client] = self.tick[client] + 1
        #for i in range(7, 2):
        #if depth > 8:
        #    raise Exception, "not supported"

        if not self.persistant_store.has_key(client):
            # n last lists of suspects.
            self.persistant_store[client] = \
                [None]* depth

        ps = self.persistant_store
        c = client

        if depth == 1:
            return self.analyze(c)

        if verbose:
            print "pretick %-20s %s: %s" % \
               (client, self.tick[client], ps[client])
        # shift right
        # hva om den er to?
        if depth >= 2:
            for i in range(depth-1, 0, -1):
                #print "shift %s" % i
                self.persistant_store[c][i] = self.persistant_store[c][i-1]

        self.persistant_store[c][0] = self.analyze(c)

        if verbose:
            print "   tick %-20s %s: %s" % \
               (client, self.tick[client], ps[client])

        # AND sammen listen over true/false paa de siste n
        # samples.
        warnings = ps[c][0]
        for i in range(0, depth):
            warnings = warnings and ps[c][i]
        #print "final: ", warnings
        return warnings # alarm

    def pprint(self, d):
        import pprint
        pprint.pprint(d)

    def report(self, client, header=True):
        # lite data, aldri alarm.
        if self.clistore[client]["queries"] < 2:
            return None

        alarm = self.timely_analysis(client, \
            self.config["movingaveragedepth"], verbose=True)
        if not alarm:
            return None

        if not self.banditstore.has_key(client):
            self.banditstore[client] = []
        self.banditstore[client] += [ self.clistore[client] ]

        r = "Probable IP-over-DNS client:" + \
            "%s (%.0f%% of %.0f bytes from domain %s)" % \
                (
                client,
                self.clistore[client]["domain_max_percent"],
                self.clistore[client]["bytes"],
                self.clistore[client]["domain_max_name"],
                ),
        return " ".join(r)


