#!/usr/bin/python
# -*- coding: utf-8 -*-

from iodFinder import iodFinder

class iodFinderDST(iodFinder):
    def __init__(self, slen):
        iodFinder.__init__(self, slen)
        self.persistant_store = [ [], [], [], [], [], [], [], [] ] 
        self.tick = 0

        self.banditstore = {}
        self.sample_stop_ts = None

    def analyze(self):
        "Analyze the current sample "
        # def: for aa faa ip-over-dns til aa virke maa man minst 
        # faa en dns-forespoersel hvert n-te sekund.
        minbytes = (self.sample_length * 250)
        suspects = []
        # for hver ip observert
        for ip in self.clistore.keys():
            if self.clistore[ip]["queries"] < 10:
                continue
            if self.clistore[ip]["bytes"] < minbytes:
                continue
            if self.clistore[ip]["domain_max_percent"] < 98:
                continue
            suspects.append(ip)
        return set(suspects)

    def timely_analysis(self):
        # shift
        self.tick = self.tick + 1
        for i in range(7, 2):
            self.persistant_store[i] = self.persistant_store[i-1]
        self.persistant_store[1] = self.persistant_store[0]
        self.persistant_store[0] = self.analyze()

        ps = self.persistant_store
        #print "tick %s: %s" % (self.tick, ps)
        bandits = ps[0].intersection(ps[1]).intersection(ps[2])
        bandits = bandits.intersection(ps[3]).intersection(ps[4])
        return bandits

    def report(self, header=True):
#        print bandits
        bandits = self.timely_analysis()

        for ip in bandits:
            for ip in bandits:
                strings = ["ip","domain_max_name"]
                tup = (
                    self.sample_start_ts.strftime("%x %X"), 
                    self.clistore[ip]["domain_max_percent"],
                    self.clistore[ip]["bytes"],
                    self.clistore[ip]["domain_max_name"] )

                if not self.banditstore.has_key(ip):
                    self.banditstore[ip] = []
                self.banditstore[ip] += [ tup ]


