#!/usr/bin/python
# .- coding: utf-8 -.
# 
# wrapper for aa lese inn pcapfiler og 
# kjoere dem gjennom iodFinderKOLMO.
#
# NB: Denne haandterer n pakker klient, i 
# stedet for aa sample hver n-te sekund.
# 

import os, sys
import pcapy
from impacket.ImpactDecoder import EthDecoder
from impacket.ImpactDecoder import LinuxSLLDecoder, UDPDecoder

from ClientStorage import ClientStorage, PacketClientStorage
from ClientStorage import ByteClientStorage
from iodClientFinder import iodClientFinder
from iodClientFinderKolmo import iodClientFinderKolmo

class Timeout(Exception): pass

class Decoder():
    import datetime
    def __init__(self, pcapObj):
        datalink = pcapObj.datalink()
        if pcapy.DLT_EN10MB == datalink:
            self.decoder = EthDecoder()
        elif pcapy.DLT_LINUX_SLL == datalink:
            self.decoder = LinuxSLLDecoder()
        else:
            raise Exception("Datalink type not supported: " % \
                datalink)

        self.pcap = pcapObj
        self.UDPDecoder = UDPDecoder()

    def packetHandler(self, hdr, data):
        global clistore, eagle, max_runtime, veryfirstpacket
        p = self.decoder.decode(data)

        #packet_ts = hdr.getts()[0]
        tstuple = hdr.getts()
        ts = self.datetime.datetime.fromtimestamp(tstuple[0])
        packet_ts = ts.replace(microsecond=tstuple[1])

        if not veryfirstpacket:
            veryfirstpacket = packet_ts

        stoptime = veryfirstpacket + self.datetime.timedelta(seconds=max_runtime)
        if packet_ts >= stoptime:
            raise(Timeout, '%s seconds reached' % max_runtime)

        # hopp over ipv6-pakkene, impacket st0tter det ikke.
        ptype = "%x" % ord(p.get_data_as_string()[0])
        if ptype == "60":
            return

        ip = p.child()
        try:
            # only accept udp packets
            if ip.get_ip_p() != 17:
                return 

        except Exception, e:
            print ip
            print >>sys.stderr, e
            raise Exception
            return

        udp = ip.child()
        data = udp.get_data_as_string()

        dns1 = ord(data[2]) 
        dns2 = ord(data[3])

        dnscode = "%x%x" % (dns1, dns2)

        # standard query response, no error
        if not dnscode == "8180": 
            return

        client = ip.get_ip_dst()
        res = clistore.add( client, hdr, p )

        # if res returns something else than None, a new sample is ready. 
        if res:
            #print "yield %s packets or bytes for client %s" % (res, client)
            eagle.add( clistore.get_data(client) )
            eagle.preprocess(client)
            eagle.report(client) 

            eagle.reset(client)
            clistore.expunge(client)


    def start(self):
        self.pcap.loop(0, self.packetHandler)

if __name__ == "__main__":
    filename = sys.argv[1] 
    p = pcapy.open_offline(filename)

    # stopp etter aa ha parset pakker for n sekunder fra fila.
    #max_runtime = 300 
    max_runtime = 999999999 

    config = {
        'dev': 'eth1',
        #'kolmo_minimum': 0.50,
        'kolmo_minimum': 0.80,
        'numpackets': 20,
        #'numpackets': 100,
        'samplebytes': 10000,
        'movingaveragedepth': 1,
    }

    clistore = PacketClientStorage(packets=config["numpackets"])
    #clistore = ByteClientStorage(bytes=config["samplebytes"])
    eagle = iodClientFinderKolmo( config  )

    veryfirstpacket = None

    try:
        Decoder(p).start()
        print "dekoder returnerte"
        # få med seg det siste ~halve samplet.
    except KeyboardInterrupt:
        pass
    except Timeout:
        pass

    for client in clistore.get_clients():
        clidata = clistore.get_data(client)
        if len(clidata) == 0:
            continue
        eagle.add( clidata )
        eagle.preprocess(client)
        eagle.report(client) 

    from EagleReporter import EagleReporter, EagleLatexReporter
    reporter = EagleLatexReporter( config, filename, eagle.banditstore, \
        veryfirstts=veryfirstpacket )
    reporter.report()

